<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class BillingComparisonFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getBillingComparison($parametros, $validaPeriodoAtual, $validaPeriodoComp, $registrosVerificados)
    {
        $sqlAlter = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";

        $std = $this->connection->prepare($sqlAlter);
        $std->executeStatement();

        $sql = "SELECT * FROM (
            SELECT FAT.CODIGO,
                'F' AS IDTIPO,
                FAT.NRFATURACONT,
                FAT.NRMEDICAOFATURA,
                FAT.NRORG,
                FAT.NRSEQCONTRATO,
                FAT.NRCONTRATOFCT,
                FAT.NMCONTRATO,
                FAT.NRTIPOORCAMENTO,
                ESCOPO.NMTIPOORCAMENTO,
                FAT.NRPARCFATURA,
                PARC.NMPRINCIPALPARC AS NMPARCFATURA,
                PARC.NRINSCRICAOPARC,
                PARC.NMSECUNDARIPARC AS NMFANTASIA,
                FAT.DTINICOMPET,
                FAT.DTFINCOMPET,
                FAT.IDTPFATURA,
                FAT.IDSITUACAOFAT,
                FAT.IDSITUACAOFAT_COMP,
                FAT.IDSITUACAOMED,
                FAT.IDSITUACAOMED_COMP,
                FAT.PERIODO,
                FAT.IDREGVERIFICADO,
                FAT.IDREGVERIFICADO_COMP,
                FAT.VRVENCIMENTO,
                FAT.VRNEGCONTR,
                FAT.VRTOTAL,
                FAT.CC_FAT,
                FAT.CC_COMP,
                FAT.NRFATURACONT_COMP,
                FAT.NRMEDICAOFATURA_COMP,
                FAT.DTINICOMPET_COMP,
                FAT.DTFINCOMPET_COMP,
                FAT.PERIODO_COMP,
                FAT.VRTOTAL_COMP,
                FAT.VRDIFERENCA,
                FAT.VRPERCDIFERENCA
            FROM (
                SELECT FAT.CODIGO,
                    FAT.NRFATURACONT,
                    NVL2(FAT.NRMEDICAOFATURA, '_'||FAT.NRMEDICAOFATURA||'_', NULL) AS NRMEDICAOFATURA,
                    FAT.NRORG,
                    NVL(FAT.NRSEQCONTRATO, COMPARACAO.NRSEQCONTRATO) AS NRSEQCONTRATO,
                    NVL(FAT.NRCONTRATOFCT, COMPARACAO.NRCONTRATOFCT) AS NRCONTRATOFCT,
                    NVL(FAT.NMCONTRATO, COMPARACAO.NMCONTRATO) AS NMCONTRATO,
                    NVL(FAT.NRTIPOORCAMENTO, COMPARACAO.NRTIPOORCAMENTO) AS NRTIPOORCAMENTO,
                    NVL(FAT.NRPARCFATURA, COMPARACAO.NRPARCFATURA) AS NRPARCFATURA,
                    FAT.DTINICOMPET,
                    FAT.DTFINCOMPET,
                    NVL(FAT.IDTPFATURA, COMPARACAO.IDTPFATURA) AS IDTPFATURA,
                    FAT.IDSITUACAO AS IDSITUACAOFAT,
                    COMPARACAO.IDSITUACAO AS IDSITUACAOFAT_COMP,
                    FAT.IDSITUACAOMED AS IDSITUACAOMED,
                    COMPARACAO.IDSITUACAOMED AS IDSITUACAOMED_COMP,
                    FAT.PERIODO,
                    FAT.VRVENCIMENTO,
                    FAT.IDREGVERIFICADO,
                    COMPARACAO.IDREGVERIFICADO AS IDREGVERIFICADO_COMP,
                    FAT.VRNEGCONTR,
                    NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) AS VRTOTAL,
                    DECODE(FAT.QTAGRUPAMENTO, 0, 'C_'||FAT.NRSEQCONTRATO, 'A_'||FAT.NRAGRUPAMENTO) AS CC_FAT,
                    COMPARACAO.CC_COMP,
                    COMPARACAO.NRFATURACONT AS NRFATURACONT_COMP,
                    NVL2(COMPARACAO.NRMEDICAOFATURA, '_'||COMPARACAO.NRMEDICAOFATURA||'_', NULL) AS NRMEDICAOFATURA_COMP,
                    COMPARACAO.DTINICOMPET AS DTINICOMPET_COMP,
                    COMPARACAO.DTFINCOMPET AS DTFINCOMPET_COMP,
                    NVL2(COMPARACAO.NRFATURACONT, TO_CHAR(COMPARACAO.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(COMPARACAO.DTFINCOMPET, 'DD/MM/YYYY'), NULL) AS PERIODO_COMP,
                    NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO) AS VRTOTAL_COMP,
                    DECODE(FAT.PERIODO, NULL, NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO), 
                           DECODE(COMPARACAO.DTINICOMPET, NULL, NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO), 
                                  NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO))) AS VRDIFERENCA,
                    DECODE(FAT.PERIODO, NULL, 100, 
                            DECODE(COMPARACAO.DTINICOMPET, NULL, 100,
                                   ROUND(ABS(NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO)) / DECODE(NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO), 0, 1, NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO)) * 100, 2))) AS VRPERCDIFERENCA
                FROM (
                    SELECT FAT.*,
                        'F_'||FAT.NRFATURACONT AS CODIGO,
                        (SELECT MAX(NRAGRUPAMENTO)
                                FROM FCT_RELACAGRUPAMENTOCONT
                                WHERE INSTR(FAT.NRSEQCONTRATO, '_' || NRSEQCONTRATO || '_') > 0) AS NRAGRUPAMENTO,
                        NVL((SELECT COUNT(NRAGRUPAMENTO)
                                FROM FCT_RELACAGRUPAMENTOCONT
                                WHERE INSTR(FAT.NRSEQCONTRATO, '_' || NRSEQCONTRATO || '_') > 0), 0) AS QTAGRUPAMENTO
                    FROM (
                        SELECT FAT.NRFATURACONT,
                            FAT.NRORG,
                            LISTAGG(AGRUPCONT.NRSEQCONTRATO, '_') WITHIN GROUP(ORDER BY AGRUPCONT.NRSEQCONTRATO) AS NRSEQCONTRATO,
                            DECODE(AGRUPCONT.IDPARCAGRUP, 'N', LISTAGG(CONT.NRCONTRATOFCT, '_') WITHIN GROUP(ORDER BY AGRUPCONT.NRSEQCONTRATO), 'AGRUPAMENTO') AS NRCONTRATOFCT,
                            DECODE(AGRUPCONT.IDPARCAGRUP, 'N', LISTAGG(CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT, '_') 
                            WITHIN GROUP(ORDER BY AGRUPCONT.NRSEQCONTRATO), 'AGRUPAMENTO') AS NMCONTRATO,
                            CONT.NRTIPOORCAMENTO,
                            LISTAGG(AGRUPCONT.NRMEDICAOFATURA, '_') WITHIN GROUP(ORDER BY AGRUPCONT.NRMEDICAOFATURA) AS NRMEDICAOFATURA,
                            MED.IDSITUACAO AS IDSITUACAOMED,
                            FAT.DTINICOMPET,
                            FAT.DTFINCOMPET,
                            FAT.NRPARCFATURA,
                            FAT.IDTPFATURA,
                            FAT.IDSITUACAO,
                            TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') AS PERIODO,
                            FAT.VRVENCIMENTO,
                            FAT.VRNEGCONTR,
                            FAT.IDREGVERIFICADO
                        FROM FCT_FATURACONT FAT
                        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                            ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
                        LEFT JOIN FCT_MEDICAOFATURA MED
                            ON AGRUPCONT.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                        LEFT JOIN FCT_CONTRATO CONT
                            ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                        WHERE (INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(CONT.NRSEQCONTRATO) || '_') > 0 OR :NRSEQCONTRATO IS NULL)
                        AND (INSTR(:NRPARCNEGOCIO, '_' || TO_CHAR(FAT.NRPARCFATURA) || '_') > 0 OR :NRPARCNEGOCIO IS NULL)
                        AND (INSTR(:NRTIPOORCAMENTO, '_' || TO_CHAR(CONT.NRTIPOORCAMENTO) || '_') > 0 OR :NRTIPOORCAMENTO IS NULL)
                        AND (INSTR(:IDTPFATURA, '_' || TO_CHAR(FAT.IDTPFATURA) || '_') > 0 OR :IDTPFATURA IS NULL)
                        AND TRUNC(FAT.DTINICOMPET) BETWEEN TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY') AND LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'))
                        AND TRUNC(FAT.DTFINCOMPET) BETWEEN TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY') AND LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'))
                        GROUP BY FAT.NRFATURACONT,
                            FAT.NRORG,
                            CONT.NRTIPOORCAMENTO,
                            AGRUPCONT.IDPARCAGRUP,
                            MED.IDSITUACAO,
                            FAT.DTINICOMPET,
                            FAT.DTFINCOMPET,
                            FAT.NRPARCFATURA,
                            FAT.IDTPFATURA,
                            FAT.IDSITUACAO,
                            FAT.VRVENCIMENTO,
                            FAT.VRNEGCONTR,
                            FAT.IDREGVERIFICADO
                    ) FAT
                ) FAT
                FULL JOIN (
                    SELECT COMP.*,
                    NVL2(COMP.NRFATURACONT, DECODE(COMP.QTAGRUPAMENTO, 0, 'C_'||COMP.NRSEQCONTRATO, 'A_'||COMP.NRAGRUPAMENTO), NULL) AS CC_COMP
                    FROM (
                        SELECT COMP.*,
                            (SELECT MAX(NRAGRUPAMENTO)
                                    FROM FCT_RELACAGRUPAMENTOCONT
                                    WHERE INSTR(COMP.NRSEQCONTRATO, '_' || NRSEQCONTRATO || '_') > 0) AS NRAGRUPAMENTO,
                            NVL((SELECT COUNT(NRAGRUPAMENTO)
                                    FROM FCT_RELACAGRUPAMENTOCONT
                                    WHERE INSTR(COMP.NRSEQCONTRATO, '_' || NRSEQCONTRATO || '_') > 0), 0) AS QTAGRUPAMENTO
                        FROM (
                        SELECT FATC.NRFATURACONT,
                            FATC.DTINICOMPET,
                            FATC.DTFINCOMPET,
                            FATC.IDSITUACAO,
                            FATC.VRVENCIMENTO,
                            FATC.VRFATURADO,
                            FATC.VRFALTAFATURAR,
                            FATC.VRNEGCONTR,
                            FATC.NRPARCFATURA,
                            FATC.IDTPFATURA,
                            FATC.IDREGVERIFICADO,
                            LISTAGG(RELC.NRMEDICAOFATURA, '_') WITHIN GROUP(ORDER BY RELC.NRMEDICAOFATURA) AS NRMEDICAOFATURA,
                            MED.IDSITUACAO AS IDSITUACAOMED,
                            LISTAGG(RELC.NRSEQCONTRATO, '_') WITHIN GROUP(ORDER BY RELC.NRSEQCONTRATO) AS NRSEQCONTRATO,
                            DECODE(RELC.IDPARCAGRUP, 'N', LISTAGG(CONT.NRCONTRATOFCT, '_') WITHIN GROUP(ORDER BY RELC.NRSEQCONTRATO), 'AGRUPAMENTO') AS NRCONTRATOFCT,
                            DECODE(RELC.IDPARCAGRUP, 'N', LISTAGG(CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT, '_') 
                            WITHIN GROUP(ORDER BY RELC.NRSEQCONTRATO), 'AGRUPAMENTO') AS NMCONTRATO,
                            CONT.NRTIPOORCAMENTO
                        FROM FCT_FATURACONT FATC
                        LEFT JOIN FCT_RELACAGRUPCONTFAT RELC
                            ON FATC.NRFATURACONT = RELC.NRFATURACONT
                        LEFT JOIN FCT_MEDICAOFATURA MED
                            ON RELC.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                        LEFT JOIN FCT_CONTRATO CONT
                            ON RELC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                        WHERE TRUNC(FATC.DTINICOMPET) BETWEEN ADD_MONTHS(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'), - :QTPARCELAS) 
                        AND ADD_MONTHS(LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY')), - :QTPARCELAS)
                        AND TRUNC(FATC.DTFINCOMPET) BETWEEN ADD_MONTHS(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'), - :QTPARCELAS) 
                        AND ADD_MONTHS(LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY')), - :QTPARCELAS)
                        GROUP BY FATC.NRFATURACONT,
                            FATC.DTINICOMPET,
                            FATC.DTFINCOMPET,
                            FATC.IDSITUACAO,
                            FATC.VRVENCIMENTO,
                            FATC.VRFATURADO,
                            FATC.VRFALTAFATURAR,
                            FATC.VRNEGCONTR,
                            FATC.NRPARCFATURA,
                            FATC.IDTPFATURA,
                            MED.IDSITUACAO,
                            RELC.IDPARCAGRUP,
                            CONT.NRTIPOORCAMENTO,
                            FATC.IDREGVERIFICADO
                        ) COMP
                    ) COMP
                    WHERE (INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(COMP.NRSEQCONTRATO) || '_') > 0 OR :NRSEQCONTRATO IS NULL)
                    AND (INSTR(:NRPARCNEGOCIO, '_' || TO_CHAR(COMP.NRPARCFATURA) || '_') > 0 OR :NRPARCNEGOCIO IS NULL)
                    AND (INSTR(:NRTIPOORCAMENTO, '_' || TO_CHAR(COMP.NRTIPOORCAMENTO) || '_') > 0 OR :NRTIPOORCAMENTO IS NULL)
                    AND (INSTR(:IDTPFATURA, '_' || TO_CHAR(COMP.IDTPFATURA) || '_') > 0 OR :IDTPFATURA IS NULL)
                ) COMPARACAO
                    ON FAT.NRPARCFATURA  = COMPARACAO.NRPARCFATURA
                AND FAT.IDTPFATURA    = COMPARACAO.IDTPFATURA
                AND DECODE(FAT.QTAGRUPAMENTO, 0, 'C_'||FAT.NRSEQCONTRATO, 'A_'||FAT.NRAGRUPAMENTO) = COMPARACAO.CC_COMP
            ) FAT
            LEFT JOIN PARCNEGOCIO PARC
                ON FAT.NRPARCFATURA = PARC.NRPARCNEGOCIO
            LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                ON FAT.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
            
            UNION ALL

            SELECT MED.CODIGO,
                'M' AS IDTIPO,
                MED.NRFATURACONT,
                TO_CHAR(MED.NRMEDICAOFATURA) AS NRMEDICAOFATURA,
                MED.NRORG,
                TO_CHAR(MED.NRSEQCONTRATO) AS NRSEQCONTRATO,
                MED.NRCONTRATOFCT,
                MED.NMCONTRATO,
                MED.NRTIPOORCAMENTO,
                ESCOPO.NMTIPOORCAMENTO,
                MED.NRPARCFATURA,
                PARC.NMPRINCIPALPARC AS NMPARCFATURA,
                PARC.NRINSCRICAOPARC,
                PARC.NMSECUNDARIPARC AS NMFANTASIA,
                MED.DTINICOMPET,
                MED.DTFINCOMPET,
                'X' AS IDTPFATURA,
                NULL AS IDSITUACAOFAT,
                NULL AS IDSITUACAOFAT_COMP,
                MED.IDSITUACAOMED,
                MED.IDSITUACAOMED_COMP,
                MED.PERIODO,
                MED.IDREGVERIFICADO,
                MED.IDREGVERIFICADO_COMP,
                MED.VRMEDICAO AS VRVENCIMENTO,
                MED.VRNEGCONTR,
                MED.VRTOTAL,
                MED.CC_FAT,
                MED.CC_COMP,
                MED.NRFATURACONT_COMP,
                TO_CHAR(MED.NRMEDICAOFATURA_COMP) AS NRMEDICAOFATURA_COMP,
                MED.DTINICOMPET_COMP,
                MED.DTFINCOMPET_COMP,
                MED.PERIODO_COMP,
                MED.VRTOTAL_COMP,
                MED.VRDIFERENCA,
                MED.VRPERCDIFERENCA
            FROM (
                SELECT MED.CODIGO,
                        MED.NRFATURACONT,
                        MED.NRMEDICAOFATURA,
                        MED.NRORG,
                        NVL(MED.NRSEQCONTRATO, COMPARACAO.NRSEQCONTRATO) AS NRSEQCONTRATO,
                        NVL(MED.NRCONTRATOFCT, COMPARACAO.NRCONTRATOFCT) AS NRCONTRATOFCT,
                        NVL(MED.NMCONTRATO, COMPARACAO.NMCONTRATO) AS NMCONTRATO,
                        NVL(MED.NRTIPOORCAMENTO, COMPARACAO.NRTIPOORCAMENTO) AS NRTIPOORCAMENTO,
                        NVL(MED.NRPARCFATURA, COMPARACAO.NRPARCFATURA) AS NRPARCFATURA,
                        MED.DTINICOMPET,
                        MED.DTFINCOMPET,
                        MED.IDSITUACAOMED,
                        COMPARACAO.IDSITUACAO AS IDSITUACAOMED_COMP,
                        MED.PERIODO,
                        MED.VRMEDICAO,
                        MED.VRNEGCONTR,
                        MED.IDREGVERIFICADO,
                        COMPARACAO.IDREGVERIFICADO AS IDREGVERIFICADO_COMP,
                        MED.VRTOTAL,
                        MED.CC_FAT,
                        NVL2(COMPARACAO.NRMEDICAOFATURA, 'C_'||COMPARACAO.NRSEQCONTRATO, NULL) AS CC_COMP,
                        NULL AS NRFATURACONT_COMP,
                        COMPARACAO.NRMEDICAOFATURA AS NRMEDICAOFATURA_COMP,
                        COMPARACAO.DTINICOMPET AS DTINICOMPET_COMP,
                        COMPARACAO.DTFINCOMPET AS DTFINCOMPET_COMP,
                        NVL2(COMPARACAO.NRMEDICAOFATURA, TO_CHAR(COMPARACAO.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(COMPARACAO.DTFINCOMPET, 'DD/MM/YYYY'), NULL) AS PERIODO_COMP,
                        NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO) AS VRTOTAL_COMP,
                        DECODE(MED.PERIODO, NULL, NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO), 
                           DECODE(COMPARACAO.DTINICOMPET, NULL, NVL(MED.VRNEGCONTR, MED.VRMEDICAO), 
                                  NVL(MED.VRNEGCONTR, MED.VRMEDICAO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO))) AS VRDIFERENCA,
                        DECODE(MED.PERIODO, NULL, 100, 
                            DECODE(COMPARACAO.DTINICOMPET, NULL, 100,
                                   ROUND(ABS(NVL(MED.VRNEGCONTR, MED.VRMEDICAO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO)) / DECODE(NVL(MED.VRNEGCONTR, MED.VRMEDICAO), 0, 1, NVL(MED.VRNEGCONTR, MED.VRMEDICAO)) * 100, 2))) AS VRPERCDIFERENCA
                    FROM (
                        SELECT 'M_' || MED.NRMEDICAOFATURA AS CODIGO,
                                NULL AS NRFATURACONT,
                                MED.NRMEDICAOFATURA,
                                MED.NRORG,
                                MED.NRSEQCONTRATO,
                                MED.NRCONTRATOFCT,
                                MED.NMCONTRATO,
                                MED.NRTIPOORCAMENTO,
                                MED.NRPARCFATURA,
                                MED.DTINICOMPET,
                                MED.DTFINCOMPET,
                                MED.IDSITUACAO AS IDSITUACAOMED,
                                NVL2(MED.NRMEDICAOFATURA, TO_CHAR(MED.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(MED.DTFINCOMPET, 'DD/MM/YYYY'), NULL) AS PERIODO,
                                MED.VRMEDICAO,
                                MED.VRNEGCONTR,
                                MED.IDREGVERIFICADO,
                                NVL(MED.VRNEGCONTR, MED.VRMEDICAO) AS VRTOTAL,
                                'C_'||MED.NRSEQCONTRATO AS CC_FAT
                        FROM (
                            SELECT MED.NRMEDICAOFATURA,
                                    MED.NRORG,
                                    MED.NRSEQCONTRATO,
                                    CONT.NRTIPOORCAMENTO,
                                    CONT.NRCONTRATOFCT,
                                    CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT AS NMCONTRATO,
                                    MED.NRPARCFATURA,
                                    MED.DTINICOMPET,
                                    MED.DTFINCOMPET,
                                    MED.IDSITUACAO,
                                    MED.VRMEDICAO,
                                    MED.VRNEGCONTR,
                                    MED.IDREGVERIFICADO
                                FROM FCT_MEDICAOFATURA MED
                                INNER JOIN FCT_CONTRATO CONT
                                ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                                WHERE (INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(CONT.NRSEQCONTRATO) || '_') > 0 OR :NRSEQCONTRATO IS NULL)
                                AND (INSTR(:NRPARCNEGOCIO, '_' || TO_CHAR(MED.NRPARCFATURA) || '_') > 0 OR :NRPARCNEGOCIO IS NULL)
                                AND (INSTR(:NRTIPOORCAMENTO, '_' || TO_CHAR(CONT.NRTIPOORCAMENTO) || '_') > 0 OR :NRTIPOORCAMENTO IS NULL)
                                AND TRUNC(MED.DTINICOMPET) BETWEEN TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY') AND LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'))
                                AND TRUNC(MED.DTFINCOMPET) BETWEEN TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY') AND LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'))
                        ) MED
                    ) MED
                    FULL JOIN (
                        SELECT COMP.NRMEDICAOFATURA,
                            COMP.NRORG,
                            COMP.NRSEQCONTRATO,
                            CONT.NRTIPOORCAMENTO,
                            CONT.NRCONTRATOFCT,
                            CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT AS NMCONTRATO,
                            COMP.NRPARCFATURA,
                            COMP.DTINICOMPET,
                            COMP.DTFINCOMPET,
                            COMP.IDSITUACAO,
                            COMP.VRMEDICAO,
                            COMP.VRNEGCONTR,
                            COMP.IDREGVERIFICADO
                        FROM FCT_MEDICAOFATURA COMP
                        INNER JOIN FCT_CONTRATO CONT
                            ON COMP.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                        WHERE (INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(COMP.NRSEQCONTRATO) || '_') > 0 OR :NRSEQCONTRATO IS NULL)
                        AND (INSTR(:NRPARCNEGOCIO, '_' || TO_CHAR(COMP.NRPARCFATURA) || '_') > 0 OR :NRPARCNEGOCIO IS NULL)
                        AND (INSTR(:NRTIPOORCAMENTO, '_' || TO_CHAR(CONT.NRTIPOORCAMENTO) || '_') > 0 OR :NRTIPOORCAMENTO IS NULL)
                        AND TRUNC(COMP.DTINICOMPET) BETWEEN ADD_MONTHS(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'), - :QTPARCELAS) 
                        AND ADD_MONTHS(LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY')), - :QTPARCELAS)
                        AND TRUNC(COMP.DTFINCOMPET) BETWEEN ADD_MONTHS(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY'), - :QTPARCELAS) 
                        AND ADD_MONTHS(LAST_DAY(TO_DATE('01/'||:MESCOMPET, 'DD/MM/YYYY')), - :QTPARCELAS)
                        AND COMP.IDSITUACAO <> '4'
                    ) COMPARACAO
                    ON MED.NRPARCFATURA = COMPARACAO.NRPARCFATURA
                    AND MED.NRSEQCONTRATO = COMPARACAO.NRSEQCONTRATO
                    AND (SELECT LISTAGG(CDSERVORCA, ',') WITHIN GROUP(ORDER BY CDSERVORCA) FROM FCT_ITMEDICAOFATURA
                        WHERE NRMEDICAOFATURA = MED.NRMEDICAOFATURA)
                    =
                    (SELECT LISTAGG(CDSERVORCA, ',') WITHIN GROUP(ORDER BY CDSERVORCA) FROM FCT_ITMEDICAOFATURA
                        WHERE NRMEDICAOFATURA = COMPARACAO.NRMEDICAOFATURA)
            ) MED
            LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                ON MED.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
            LEFT JOIN PARCNEGOCIO PARC
                ON MED.NRPARCFATURA = PARC.NRPARCNEGOCIO
        )
        WHERE (VRPERCDIFERENCA >= :VRPERCDIFERENCA_DE OR :VRPERCDIFERENCA_DE IS NULL)
        AND (VRPERCDIFERENCA <= :VRPERCDIFERENCA_ATE OR :VRPERCDIFERENCA_ATE IS NULL)
        AND (VRDIFERENCA >= :VRDIFERENCA_DE OR :VRDIFERENCA_DE IS NULL)
        AND (VRDIFERENCA <= :VRDIFERENCA_ATE OR :VRDIFERENCA_ATE IS NULL)
        AND IDTIPO = :IDTIPO
        $validaPeriodoAtual
        $validaPeriodoComp
        $registrosVerificados
        ORDER BY NRCONTRATOFCT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function verificarRegParcela($parametros, $arrayFormatado)
    {
        $sql = "UPDATE FCT_FATURACONT
                    SET IDREGVERIFICADO = :IDREGVERIFICADO,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTULTATU = SYSDATE,
                        NRORGULTATU = :NRORGULTATU
                    WHERE NRFATURACONT IN ($arrayFormatado)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getVerRegParcela($parametros)
    {

        $sql = "SELECT IDREGVERIFICADO 
                FROM FCT_FATURACONT
                WHERE NRFATURACONT = :NRFATURACONT";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function verificarRegMedicao($parametros, $arrayFormatado)
    {
        $sql = "UPDATE FCT_MEDICAOFATURA
                    SET IDREGVERIFICADO = :IDREGVERIFICADO,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTULTATU = SYSDATE,
                        NRORGULTATU = :NRORGULTATU
                    WHERE NRMEDICAOFATURA IN ($arrayFormatado)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getVerRegMedicao($parametros)
    {

        $sql = "SELECT IDREGVERIFICADO 
                FROM FCT_MEDICAOFATURA
                WHERE NRMEDICAOFATURA = :NRMEDICAOFATURA";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getContractsBillingComparison()
    {
        $sql = "SELECT CONT.NRSEQCONTRATO,
                       CONT.NRCONTRATOFCT,
                       CONT.NRCONTRATOFCT ||' - '|| PARC.NMSECUNDARIPARC AS NMCONTRATO
                  FROM FCT_CONTRATO CONT
                  JOIN PARCNEGOCIO PARC
                    ON CONT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBusinessPartnersBilling()
    {
        $sql = "SELECT NRPARCNEGOCIO, NMSECUNDARIPARC
                  FROM PARCNEGOCIO
                 WHERE CDTIPOPARCPRINCIPAL = 'CLIENTE'
                   AND IDATIVO = 'S'
                   ORDER BY NMSECUNDARIPARC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBillingScopes()
    {
        $sql = "SELECT NRTIPOORCAMENTO, NMTIPOORCAMENTO
                FROM FCT_TIPOORCAMENTO
                WHERE IDATIVO = 'S'
                ORDER BY NMTIPOORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function billingComparisonOfTheParcelTab($parametros)
    {
        $sql = "SELECT ITFAT.NRITFATURACONT,
                   ITFAT.NRFATURACONT,
                   ITFAT.NRSEQCONTRATO,
                   ITFAT.NRITEMOCONTRATO,
                   ITCONT.NMITEMCONTRATO || ' - ' || CONT.NRCONTRATOFCT || ' - ' || CONT.DSREFERENCIACONT AS NMITEMCONTRATO,
                   ITFAT.IDSITUACAO,
                   ITFAT.VRVENCIMENTO,
                   ITFAT.VRFATURADO,
                   ITFAT.VRFALTAFATURAR,
                   ITFAT.DSJUSTIFICATIVA,
                   ITFAT.IDATIVO,
                   ITFAT.NRORG,
                   ITFAT.VRNEGCONTR
              FROM FCT_ITFATURACONT ITFAT
             INNER JOIN FCT_ITEMCONTRATO ITCONT
                ON ITFAT.NRSEQCONTRATO   = ITCONT.NRSEQCONTRATO
               AND ITFAT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
               AND ITFAT.NRORG           = ITCONT.NRORG
             INNER JOIN FCT_CONTRATO CONT
                ON ITFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
             WHERE ITFAT.NRFATURACONT = :NRFATURACONT
             ORDER BY ITCONT.NRSEQCONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData(
            $this->entityManager,
            $sql,
            $parametros
        );
    }

    public function billingComparisonOfMeasurementItems($parametros)
    {
        //  INSTR(:NRMEDICAOFATURA, '_'  TO_CHAR(NRMEDICAOFATURA)  '_') > 0) Comando retirado do select pois o mesmo estava impedindo o retorno dos registros.
        $sql = "SELECT
                NRITMEDICAOFATURA,
                NRMEDICAOFATURA,
                NRSEQCONTRATO,
                NRITEMOCONTRATO,
                NMITEMCONTRATO,
                CDSERVORCA,
                CDPRODFATURA,
                IDSITUACAO,
                VRTOTITEMCONT,
                DECODE(VRTOTITEMCONT, 0, 0,(VRDESCITEM * 100) / VRTOTITEMCONT) AS VRPERCDESCITEM,
                VRDESCITEM,
                VRITEMCONT AS VRTOTITEMCOMDESC,
                IDATIVO,
                NRORG,
                DTINCLUSAO,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                DTULTATU,
                NRORGULTATU,
                CDOPERULTATU,
                VRNEGCONTR,
                NRPARCELASNEGCONTR
            FROM
                (SELECT
                        ITMED.NRITMEDICAOFATURA,
                        ITMED.NRMEDICAOFATURA,
                        ITMED.NRSEQCONTRATO,
                        ITMED.NRITEMOCONTRATO,
                        ITCONT.NMITEMCONTRATO || ' - ' || CONT.NRCONTRATOFCT || ' - ' || CONT.DSREFERENCIACONT AS NMITEMCONTRATO,
                        ITMED.CDSERVORCA,
                        ITMED.CDPRODFATURA,
                        ITMED.IDSITUACAO,
                        ITMED.VRTOTITEMCONT,
                        ITMED.VRITEMCONT,
                        NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0) AS VRDESCITEM,
                        ITMED.IDATIVO,
                        ITMED.NRORG,
                        ITMED.DTINCLUSAO,
                        ITMED.NRORGINCLUSAO,
                        ITMED.CDOPERINCLUSAO,
                        ITMED.DTULTATU,
                        ITMED.NRORGULTATU,
                        ITMED.CDOPERULTATU,
                        ITMED.VRNEGCONTR,
                        ITMED.NRPARCELASNEGCONTR
                   FROM FCT_ITMEDICAOFATURA ITMED
                  INNER JOIN FCT_ITEMCONTRATO ITCONT
                     ON ITMED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                    AND ITMED.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                    AND ITMED.NRORG = ITCONT.NRORG
                  INNER JOIN FCT_CONTRATO CONT
                     ON ITMED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                     ON ITMED.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                    AND ITMED.NRORG = ITNEG.NRORG
                   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEG
                     ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                    AND ITNEG.NRORG = NEG.NRORG
                  WHERE NRMEDICAOFATURA = :NRMEDICAOFATURA)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function billingComparisonOfVariableMeasures($parametros)
    {
        $sql = "SELECT
                NRMEDICAOFATURA,
                IDELEMENTORAIZ,
                NMELEMENTORAIZ,
                CDTPMEDIDAVARIAVEL,
                DSTPMEDIDAVARIAVEL,
                QTMEDIDAVARIAVEL,
                IDMULTIPVARIACAO,
                IDCALCULADO,
                IDATIVO,
                NRORG,
                QTFRANQUIA,
                QTMEDIDAMEDICAO,
                VRITEMCONT,
                QTMEDIDAVENDIDA,
                NRSEQCONTRATO,
                VRUNITARIO,
                VRPRECOVARIACAO,
                QTMEDIDACONTR,
                VRTOTAL,
                CASE
                    WHEN VRITEMCONTCOMDESC IS NOT NULL THEN
                        VRITEMCONTCOMDESC
                    WHEN NVL(VRDESCITEM, 0) > 0 THEN
                        DECODE(IDTPDESCONTO, 'V', VRTOTAL - VRDESCITEM, VRTOTAL - ROUND((VRTOTAL * VRPERCDESCITEM / 100), 2))
                    ELSE
                        VRTOTAL
                END AS VRTOTALCOMDESC,
                CDSERVORCA,
                NRMEDVARMEDICAOFATURA,
                IDTPDESCONTO,
                VRDESCITEM,
                VRPERCDESCITEM,
                VRITEMCONTCOMDESC,
                VRNEGCONTR,
                NRPARCELASNEGCONTR
            FROM
                (
                    SELECT
                        NRMEDICAOFATURA,
                        IDELEMENTORAIZ,
                        NMELEMENTORAIZ,
                        CDTPMEDIDAVARIAVEL,
                        DSTPMEDIDAVARIAVEL,
                        QTMEDIDAVARIAVEL,
                        IDMULTIPVARIACAO,
                        IDCALCULADO,
                        IDATIVO,
                        NRORG,
                        QTFRANQUIA,
                        QTMEDIDAMEDICAO,
                        VRITEMCONT,
                        QTMEDIDAVENDIDA,
                        NRSEQCONTRATO,
                        DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO, DECODE(IDELEMENTORAIZ, NULL, VRUNITARIO, DECODE(IDPREVCOBRFUT, 'S', VRUNITARIO
                        , VRUNITARIO * QTMEDIDACONTR))) AS VRUNITARIO,
                        VRPRECOVARIACAO,
                        QTMEDIDACONTR,
                        DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, DECODE(IDELEMENTORAIZ, NULL, VRUNITARIO * QTMEDIDAMEDICAO
                        , DECODE(IDPREVCOBRFUT, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR))) AS VRTOTAL,
                        CDSERVORCA,
                        NRMEDVARMEDICAOFATURA,
                        IDTPDESCONTO,
                        VRDESCITEM,
                        VRPERCDESCITEM,
                        VRITEMCONTCOMDESC,
                        VRNEGCONTR,
                        NRPARCELASNEGCONTR
                    FROM
                        (
                            SELECT DISTINCT
                                MEDVAR.NRMEDVARMEDICAOFATURA,
                                MEDVAR.CDSERVORCA,
                                MEDVAR.NRMEDICAOFATURA,
                                MEDVAR.IDELEMENTORAIZ,
                                ELE.NMSERVORCA            AS NMELEMENTORAIZ,
                                MEDVAR.CDTPMEDIDAVARIAVEL,
                                MEDIDA.DSTPMEDIDASERV     AS DSTPMEDIDAVARIAVEL,
                                MEDVAR.QTMEDIDAVARIAVEL,
                                MEDVAR.IDMULTIPVARIACAO,
                                MEDVAR.IDCALCULADO,
                                MEDVAR.IDATIVO,
                                MEDVAR.NRORG,
                                MEDVAR.QTFRANQUIA,
                                MEDVAR.QTMEDIDAMEDICAO,
                                MEDVAR.VRITEMCONT,
                                MEDVAR.QTMEDIDAVENDIDA,
                                MED.NRSEQCONTRATO,
                                VAR.VRPRECOVARIACAO       AS VRPRECOVARIACAO,
                                VARVEND.VRPRECOVARIACAO   AS VRPRECOVARIACAOVEND,
                                ITCONT.VRUNITITEMCONT,
                                DECODE(MEDVAR.IDELEMENTORAIZ, NULL, MEDVAR.QTMEDIDAVENDIDA, ITCONT.QTMEDIDACONTR) AS QTMEDIDACONTR,
                                DECODE(MEDVAR.IDELEMENTORAIZ, NULL, NVL(VAR.VRPRECOVARIACAO, ITCONT.VRUNITITEMCONT), DECODE(NVL(VAR.VRPRECOVARIACAO
                                , 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, VAR.VRPRECOVARIACAO, ITCONT.VRUNITITEMCONT
                                / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO))) AS VRUNITARIO,
                                ITNEG.IDTPDESCONTO,
                                ITNEG.VRDESCITEM,
                                ITNEG.VRPERCDESCITEM,
                                MEDVAR.VRITEMCONTCOMDESC,
                                MEDVAR.VRNEGCONTR,
                                MEDVAR.NRPARCELASNEGCONTR,
                                NEG.IDPREVCOBRFUT
                            FROM FCT_MEDVARMEDICAOFATURA    MEDVAR
                            JOIN FCT_MEDICAOFATURA MED
                              ON MEDVAR.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                            JOIN FCT_ITEMCONTRATO ITCONT
                              ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                             AND MEDVAR.CDSERVORCA = ITCONT.CDSERVORCA
                             AND MEDVAR.CDTPMEDIDAVARIAVEL = ITCONT.CDTPMEDIDAVARIAVEL
                             AND ( MEDVAR.IDELEMENTORAIZ = ITCONT.IDELEMENTO
                                    OR MEDVAR.IDELEMENTORAIZ IS NULL
                                    AND ITCONT.NRITEMCONTRATOPAI IS NULL )
                            JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                              ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                            JOIN FCT_NEGOCIACAOCONTRATO NEG
                              ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                           INNER JOIN FCT_VARPRECBASESERVCONT    VAR
                              ON MED.NRSEQCONTRATO = VAR.NRSEQCONTRATO
                             AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                             AND MEDVAR.CDSERVORCA = VAR.CDSERVORCA
                             AND ( ( MEDVAR.IDELEMENTORAIZ IS NOT NULL
                                        AND ITCONT.CDTPMEDIDASERV = VAR.CDTPMEDIDASERV )
                                        OR MEDVAR.IDELEMENTORAIZ IS NULL )
                             AND DECODE(MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA, 0, 1, MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO
                             AND VAR.QTMEDIDAFIMVARIACAO
                            LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND
                              ON MED.NRSEQCONTRATO = VARVEND.NRSEQCONTRATO
                             AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                             AND MED.NRORG = VARVEND.NRORG
                             AND MEDVAR.CDSERVORCA = VARVEND.CDSERVORCA
                             AND ( ( MEDVAR.IDELEMENTORAIZ IS NOT NULL
                                        AND ITCONT.CDTPMEDIDASERV = VARVEND.CDTPMEDIDASERV )
                                        OR MEDVAR.IDELEMENTORAIZ IS NULL )
                             AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO
                             AND VARVEND.QTMEDIDAFIMVARIACAO
                            LEFT JOIN FCT_SERVICOORCA            ELE
                              ON ( MEDVAR.IDELEMENTORAIZ = ELE.IDELEMENTO
                                        OR MEDVAR.IDELEMENTORAIZ IS NULL
                                        AND MEDVAR.CDSERVORCA = ELE.CDSERVORCA )
                             AND MEDVAR.NRORG = ELE.NRORG
                            LEFT JOIN FCT_TIPOMEDIDASERV MEDIDA
                              ON MEDVAR.CDTPMEDIDAVARIAVEL = MEDIDA.CDTPMEDIDASERV
                             AND MEDVAR.NRORG = MEDIDA.NRORG
                           WHERE MED.NRMEDICAOFATURA = :NRMEDICAOFATURA))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
}
