/******************************************************************************/
/* SISTEMAS INTEGRADOS TECNISA                                                */
/*                                                                            */
/* COMPRAS E SUPRIMENTOS                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* NOME: 8270_CMPTRGO_NF_BAIXA_SAIDA                                          */
/*                                                                            */
/* DESCRIO:                                                                 */
/* ALTERA O IDENTIFICADOR DE BAIXA DE UMA AF E DOS SEUS ITENS DE ACORDO COM   */
/* COM OS ITENS DA NF.                                                        */
/*                                                                            */
/* CRIAO:                                                                   */
/* 30/08/99 - YORIS L. DE SOUZA                                               */
/*                                                                            */
/* MANUTENES TRG :                                                          */
/* 23/09/99 - YORIS L. DE SOUZA                                               */
/*                                                                            */
/******************************************************************************/
/******************************************************************************/
/* @C:\web_511\sql\end_conv\oracle\8270_CMPTRGO_NF_BAIXA_SAIDA.SQL            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER NF_BAIXA_SAIDA
BEFORE DELETE OR INSERT OR UPDATE OF QTITEMPROD
ON ITEMPRODUTO FOR EACH ROW

DECLARE
   V_DTENTRSAID   NOTAFISCAL.DTENTRSAID%TYPE;
   V_IDBAIXAAF    AUTOFORNE.IDBAIXAAF%TYPE;
   V_IDBAIXITMAF  ITEMAUTF.IDBAIXITMAF%TYPE;

   V_TOTALITEM    NUMBER;
   V_BAIXATOTAL   NUMBER;
   V_BAIXAMANUAL  NUMBER;
   V_EMABERTO     NUMBER;
   V_BAIXAPARCIAL NUMBER;
   V_VRFATOCONV   NUMBER;

   V_IDENTRSAIDOP NOTAFISCAL.IDENTRSAIDOP%TYPE;
   V_CDFILIEMIT   NOTAFISCAL.CDFILIEMIT%TYPE;
   V_CDFILIRECE   NOTAFISCAL.CDFILIRECE%TYPE;
   V_NRSOLICMP    NFRELACSOLI.NRSOLICMP%TYPE;

   V_CDPRODCNV    CNVPRODUNEST.CDPRUNEST%TYPE;
   V_VRFATUNEST   CNVPRODUNEST.VRFATUNEST%TYPE;

   V_QTRESTNF     NUMBER; --QUANTIDADE QUE IR AUMENTAR OU DIMINUIR NA BAIXA DAS AFS
   V_QTBAIXAAF    NUMBER; --QUANTIDADE NECESSRIA PARA COMPLETAR A BAIXA DO ITEM DA AF
   V_QTUPITEMAF   NUMBER; --QUANTIDADE QUE SER AUMENTADA OU DIMINUIDA DA BAIXA DO ITEM DA AF

   V_QTEFETENTRAF ITEMAUTF.QTEFETENTRAF%TYPE;

   V_PRODUTO      ITEMAUTF.CDPRODUTO%TYPE;
   V_CDPRODEMIS   ITEMAUTF.CDPRODUTO%TYPE;
   V_IDCONSVLRMAF PARAMGERAL.IDCONSVLRMAF%TYPE;
   V_NRLANCTONF   ITEMAUTF.NRLANCTONF%TYPE;

   C_CDFILDEST    ITEMAUTF.CDFILDEST%TYPE;
   C_CDFILLANC    ITEMAUTF.CDFILLANC%TYPE;
   C_NRAUTOFORN   ITEMAUTF.NRAUTOFORN%TYPE;
   C_CDMARCA      ITEMAUTF.CDMARCA%TYPE;
   C_CDPRODUTO    ITEMAUTF.CDPRODUTO%TYPE;
   C_DTPROGENTAF  ITEMAUTF.DTPROGENTAF%TYPE;
   C_QTPROGENTAF  ITEMAUTF.QTPROGENTAF%TYPE;
   C_QTEFETENTRAF ITEMAUTF.QTEFETENTRAF%TYPE;
   C_IDBAIXITMAF  ITEMAUTF.IDBAIXITMAF%TYPE;
   C_IDUTILITEM   VARCHAR2(1);
   V_QTITEMPROD   ITEMPRODUTO.QTITEMPROD%TYPE;

   V_COUNT        FLOAT;
   V_VRFATOCONVOL FLOAT;

   V_DTENTREGASOLI NFRELACSOLI.DTPROGENTR%TYPE;
   V_CDFILILANC    VARCHAR2(04);

/* CURSORES PARA A NFRELACAFSAI - AF REFERENTE AS NF'S DE SAIDA(OPERADOR LOGISTICO)*/
   CURSOR C_ITEMAUFSAI_INSERT IS
      SELECT
         ITEMAUTF.CDFILDEST,
         ITEMAUTF.CDFILLANC,
         ITEMAUTF.NRAUTOFORN,
         ITEMAUTF.CDMARCA,
         ITEMAUTF.CDPRODUTO,
         ITEMAUTF.DTPROGENTAF,
         ITEMAUTF.QTPROGENTAF,
         NVL(ITEMAUTF.QTEFAFSAIDOL, 0) AS QTSAIDOPLOG,
         ITEMAUTF.IDBAIXITAFS,
         '1' AS IDUTILITEM
      FROM
         ITEMAUTF, NFRELACAFSAI N, RELACPRODOL R, CNVPRODUNEST C, CNVPRODUNEST D
      WHERE
         ((:OLD.CDFILIAL    = N.CDFILIAL AND
           :OLD.NRLANCTONF  = N.NRLANCTONF) OR
          (:NEW.CDFILIAL    = N.CDFILIAL AND
           :NEW.NRLANCTONF  = N.NRLANCTONF))  AND
         N.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
         N.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
         N.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
         N.CDMARCA     = ITEMAUTF.CDMARCA     AND
         N.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
         N.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
         R.CDPRARVORIG = ITEMAUTF.CDPRODUTO   AND
         R.CDMARCA     = NVL(ITEMAUTF.CDMARCAOL, ITEMAUTF.CDMARCA) AND
         R.CDPRODARVOL = C.CDPRUNEST          AND
         C.CDPRODUTO   = D.CDPRODUTO          AND
         D.CDPRUNEST   = V_PRODUTO
      UNION
      SELECT
         ITEMPEDEXOL.CDFILDEST,
         ITEMPEDEXOL.CDFILLANC,
         ITEMPEDEXOL.NRPEDEXOL,
         ITEMPEDEXOL.CDMARCA,
         ITEMPEDEXOL.CDPRODUTO,
         ITEMPEDEXOL.DTPROGENPEOL,
         ITEMPEDEXOL.QTPROGENPEOL,
         NVL(ITEMPEDEXOL.QTEFETENPEOL, 0) AS QTSAIDOPLOG,
         ITEMPEDEXOL.IDBAIXAOLSAI,
         '2' AS IDUTILITEM
      FROM
         ITEMPEDEXOL, NFRELACPEXOL N, RELACPRODOL R
      WHERE
         ((:OLD.CDFILIAL    = N.CDFILIAL AND
           :OLD.NRLANCTONF  = N.NRLANCTONF) OR
          (:NEW.CDFILIAL    = N.CDFILIAL AND
           :NEW.NRLANCTONF  = N.NRLANCTONF))          AND
         N.CDFILDEST      = ITEMPEDEXOL.CDFILDEST     AND
         N.CDFILLANC      = ITEMPEDEXOL.CDFILLANC     AND
         N.NRPEDEXOL      = ITEMPEDEXOL.NRPEDEXOL     AND
         N.CDMARCA        = ITEMPEDEXOL.CDMARCA       AND
         N.CDPRODUTO      = ITEMPEDEXOL.CDPRODUTO     AND
         N.DTPROGENPEOL   = ITEMPEDEXOL.DTPROGENPEOL  AND
         R.CDPRARVORIG    = ITEMPEDEXOL.CDPRODUTO     AND
         R.CDMARCA        = ITEMPEDEXOL.CDMARCA       AND
         ((R.CDPRODARVOL  = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)) OR
          (EXISTS (SELECT 1
                   FROM PRODUTO
                   WHERE PRODUTO.CDPRODUTO = ITEMPEDEXOL.CDPRODUTO
                     AND PRODUTO.CDPRODESTO = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)))

          )
      ORDER BY
         1, 2, 6, 3;

   CURSOR C_ITEMAUFSAI IS
      SELECT
         ITEMAUTF.CDFILDEST,
         ITEMAUTF.CDFILLANC,
         ITEMAUTF.NRAUTOFORN,
         ITEMAUTF.CDMARCA,
         ITEMAUTF.CDPRODUTO,
         ITEMAUTF.DTPROGENTAF,
         ITEMAUTF.QTPROGENTAF,
         NVL(ITEMAUTF.QTEFAFSAIDOL, 0) AS QTSAIDOPLOG,
         ITEMAUTF.IDBAIXITAFS,
         '1' AS IDUTILITEM
      FROM
         ITEMAUTF, NFRELACAFSAI N, RELACPRODOL R, CNVPRODUNEST C, CNVPRODUNEST D
      WHERE
         ((:OLD.CDFILIAL    = N.CDFILIAL AND
           :OLD.NRLANCTONF  = N.NRLANCTONF) OR
          (:NEW.CDFILIAL    = N.CDFILIAL AND
           :NEW.NRLANCTONF  = N.NRLANCTONF))  AND
         N.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
         N.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
         N.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
         N.CDMARCA     = ITEMAUTF.CDMARCA     AND
         N.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
         N.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
         R.CDPRARVORIG = ITEMAUTF.CDPRODUTO   AND
         R.CDMARCA     = NVL(ITEMAUTF.CDMARCAOL, ITEMAUTF.CDMARCA) AND
         R.CDPRODARVOL = C.CDPRUNEST          AND
         C.CDPRODUTO   = D.CDPRODUTO          AND
         D.CDPRUNEST   = V_PRODUTO
      UNION
      SELECT
         ITEMPEDEXOL.CDFILDEST,
         ITEMPEDEXOL.CDFILLANC,
         ITEMPEDEXOL.NRPEDEXOL,
         ITEMPEDEXOL.CDMARCA,
         ITEMPEDEXOL.CDPRODUTO,
         ITEMPEDEXOL.DTPROGENPEOL,
         ITEMPEDEXOL.QTPROGENPEOL,
         NVL(ITEMPEDEXOL.QTEFETENPEOL, 0) AS QTSAIDOPLOG,
         ITEMPEDEXOL.IDBAIXAOLSAI,
         '2' AS IDUTILITEM
      FROM
         ITEMPEDEXOL, NFRELACPEXOL N, RELACPRODOL R
      WHERE
         ((:OLD.CDFILIAL    = N.CDFILIAL AND
           :OLD.NRLANCTONF  = N.NRLANCTONF) OR
          (:NEW.CDFILIAL    = N.CDFILIAL AND
           :NEW.NRLANCTONF  = N.NRLANCTONF))       AND
         N.CDFILDEST    = ITEMPEDEXOL.CDFILDEST    AND
         N.CDFILLANC    = ITEMPEDEXOL.CDFILLANC    AND
         N.NRPEDEXOL    = ITEMPEDEXOL.NRPEDEXOL    AND
         N.CDMARCA      = ITEMPEDEXOL.CDMARCA      AND
         N.CDPRODUTO    = ITEMPEDEXOL.CDPRODUTO    AND
         N.DTPROGENPEOL = ITEMPEDEXOL.DTPROGENPEOL AND
         R.CDPRARVORIG  = ITEMPEDEXOL.CDPRODUTO    AND
         R.CDMARCA      = ITEMPEDEXOL.CDMARCA      AND
         ((R.CDPRODARVOL = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)) OR
          (EXISTS (SELECT 1
                   FROM PRODUTO
                   WHERE PRODUTO.CDPRODUTO = ITEMPEDEXOL.CDPRODUTO
                     AND PRODUTO.CDPRODESTO = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)))

          )
      ORDER BY
         1, 2, 6 DESC, 3 DESC;
BEGIN
   IF NVL(:NEW.QTITEMPROD, 0) <> NVL(:OLD.QTITEMPROD, 0) THEN
      SELECT
         NVL(MAX(IDCONSVLRMAF), 'N')
      INTO
         V_IDCONSVLRMAF
      FROM
         PARAMGERAL;

      IF INSERTING THEN
         SELECT
            MAX(CDPRODUTO) INTO V_CDPRODEMIS
         FROM
            PRODUTO
         WHERE
            CDARVPROD = :NEW.CDPRODEMIS;

         IF :NEW.CDPRODUTO <> V_CDPRODEMIS THEN
            V_PRODUTO := V_CDPRODEMIS;
         ELSE
            V_PRODUTO := :NEW.CDPRODUTO;
         END IF;
      END IF;

      IF UPDATING THEN
         SELECT
            MAX(CDPRODUTO) INTO V_CDPRODEMIS
         FROM
            PRODUTO
         WHERE
            CDARVPROD = :OLD.CDPRODEMIS;

         IF :OLD.CDPRODUTO <> V_CDPRODEMIS THEN
            V_PRODUTO := V_CDPRODEMIS;
         ELSE
            V_PRODUTO := :OLD.CDPRODUTO;
         END IF;
         IF V_PRODUTO IS NULL THEN
            SELECT
               MAX(CDPRODUTO) INTO V_CDPRODEMIS
            FROM
               PRODUTO
            WHERE
               CDARVPROD = :NEW.CDPRODEMIS;

            IF :NEW.CDPRODUTO <> V_CDPRODEMIS THEN
               V_PRODUTO := V_CDPRODEMIS;
            ELSE
               V_PRODUTO := :NEW.CDPRODUTO;
            END IF;
         END IF;
      END IF;

      IF DELETING THEN
         SELECT
            MAX(CDPRODUTO) INTO V_CDPRODEMIS
         FROM
            PRODUTO
         WHERE
            CDARVPROD = :OLD.CDPRODEMIS;

         IF :OLD.CDPRODUTO <> V_CDPRODEMIS THEN
            V_PRODUTO := V_CDPRODEMIS;
         ELSE
            V_PRODUTO := :OLD.CDPRODUTO;
         END IF;
      END IF;

      SELECT
        MAX(DTENTRSAID), MAX(IDENTRSAIDOP),
        MAX(CDFILIEMIT), MAX(CDFILIRECE)
      INTO
        V_DTENTRSAID, V_IDENTRSAIDOP,
        V_CDFILIEMIT, V_CDFILIRECE
      FROM
        NOTAFISCAL
      WHERE
        ((CDFILIAL = :OLD.CDFILIAL AND NRLANCTONF = :OLD.NRLANCTONF) OR
         (CDFILIAL = :NEW.CDFILIAL AND NRLANCTONF = :NEW.NRLANCTONF));

      --SOMENTE OPERA PARA NOTAS DE SADA
      IF V_IDENTRSAIDOP = 'S' THEN

         --SELECT PARA VERIFICAR NOTAS DE OL
         SELECT MAX(N.NRLANCTONF), MAX(NVL(ROUND(D.VRFATUNEST/C.VRFATUNEST,2),1))
         INTO V_NRLANCTONF, V_VRFATOCONV
         FROM NFRELACAFSAI N, ITEMAUTF I, CNVPRODUNEST C, RELACPRODOL R, CNVPRODUNEST D
         WHERE ((:OLD.CDFILIAL = N.CDFILIAL AND :OLD.NRLANCTONF = N.NRLANCTONF)  OR
                (:NEW.CDFILIAL = N.CDFILIAL AND :NEW.NRLANCTONF = N.NRLANCTONF)) AND
                N.CDFILDEST   = I.CDFILDEST         AND
                N.CDFILLANC   = I.CDFILLANC         AND
                N.NRAUTOFORN  = I.NRAUTOFORN        AND
                N.CDMARCA     = I.CDMARCA           AND
                N.CDPRODUTO   = I.CDPRODUTO         AND
                N.DTPROGENTAF = I.DTPROGENTAF       AND
                R.CDPRARVORIG = I.CDPRODUTO         AND
                R.CDMARCA     = NVL(I.CDMARCAOL, I.CDMARCA) AND
                R.CDPRODARVOL = C.CDPRUNEST          AND
                C.CDPRODUTO   = D.CDPRODUTO          AND
                D.CDPRUNEST   = V_PRODUTO;

         --SELECT PARA VERIFICAR NOTAS DE OL
         IF V_NRLANCTONF IS NULL THEN
            V_VRFATOCONV := 1;
            SELECT MAX(N.NRLANCTONF)
            INTO V_NRLANCTONF
            FROM NFRELACPEXOL N, ITEMPEDEXOL I, RELACPRODOL R
            WHERE ((:OLD.CDFILIAL = N.CDFILIAL AND :OLD.NRLANCTONF = N.NRLANCTONF)  OR
                   (:NEW.CDFILIAL = N.CDFILIAL AND :NEW.NRLANCTONF = N.NRLANCTONF)) AND
                  N.CDFILDEST    = I.CDFILDEST         AND
                  N.CDFILLANC    = I.CDFILLANC         AND
                  N.NRPEDEXOL    = I.NRPEDEXOL         AND
                  N.CDMARCA      = I.CDMARCA           AND
                  N.CDPRODUTO    = I.CDPRODUTO         AND
                  N.DTPROGENPEOL = I.DTPROGENPEOL      AND
                  R.CDPRARVORIG  = I.CDPRODUTO         AND
                  R.CDMARCA      = NVL(I.CDMARCA, I.CDMARCA) AND
                  ((R.CDPRODARVOL  = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)) OR
                   (EXISTS (SELECT 1
                            FROM PRODUTO
                            WHERE PRODUTO.CDPRODUTO = I.CDPRODUTO
                              AND PRODUTO.CDPRODESTO = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO))));
         END IF;

         --CASO A NOTA SEJA DE OL
         IF NOT (V_NRLANCTONF IS NULL) THEN
            IF INSERTING THEN
               V_QTRESTNF   := :NEW.QTITEMPROD * V_VRFATOCONV;
               V_QTITEMPROD := :NEW.QTITEMPROD * V_VRFATOCONV;
            END IF;
            IF UPDATING THEN
               V_QTRESTNF   := (:NEW.QTITEMPROD - :OLD.QTITEMPROD) * V_VRFATOCONV;
               V_QTITEMPROD := (:NEW.QTITEMPROD - :OLD.QTITEMPROD) * V_VRFATOCONV;
            END IF;
            IF DELETING THEN
               V_QTRESTNF   := - (:OLD.QTITEMPROD * V_VRFATOCONV);
               V_QTITEMPROD := :OLD.QTITEMPROD * V_VRFATOCONV;
            END IF;

            V_QTRESTNF   := ROUND(V_QTRESTNF, 2);
            V_QTITEMPROD := ROUND(V_QTITEMPROD, 2);

            IF INSERTING THEN
               OPEN C_ITEMAUFSAI_INSERT;
            ELSE
               OPEN C_ITEMAUFSAI;
            END IF;
            LOOP
               IF INSERTING THEN
                  FETCH C_ITEMAUFSAI_INSERT INTO C_CDFILDEST,
                                                 C_CDFILLANC,
                                                 C_NRAUTOFORN,
                                                 C_CDMARCA,
                                                 C_CDPRODUTO,
                                                 C_DTPROGENTAF,
                                                 C_QTPROGENTAF,
                                                 C_QTEFETENTRAF,
                                                 C_IDBAIXITMAF,
                                                 C_IDUTILITEM;
                  EXIT WHEN C_ITEMAUFSAI_INSERT%NOTFOUND;
               ELSE
                  FETCH C_ITEMAUFSAI INTO C_CDFILDEST,
                                          C_CDFILLANC,
                                          C_NRAUTOFORN,
                                          C_CDMARCA,
                                          C_CDPRODUTO,
                                          C_DTPROGENTAF,
                                          C_QTPROGENTAF,
                                          C_QTEFETENTRAF,
                                          C_IDBAIXITMAF,
                                          C_IDUTILITEM;
                  EXIT WHEN C_ITEMAUFSAI%NOTFOUND;
               END IF;

               V_QTBAIXAAF := C_QTPROGENTAF - C_QTEFETENTRAF; -- QUNATIDADE NECESSRIA PARA COMPLETAR O CAMPO QTEFETENTRAF

               IF V_QTRESTNF <> 0 THEN --SE O ITEM NO ESTA BAIXADO TOTALMENTE E HOVER QUANTIDADE A SER ATUALIZADA NA BAIXA DO...
                  V_QTUPITEMAF := V_QTRESTNF;

                  IF V_QTRESTNF > 0 THEN                        /* ################################################ */
                     IF V_QTRESTNF > V_QTBAIXAAF THEN           /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                        V_QTUPITEMAF := V_QTBAIXAAF;            /* ################################################ */
                     END IF;
                  ELSE                                                    /* ################################################ */
                     IF ABS(V_QTRESTNF) > C_QTEFETENTRAF THEN   /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                        V_QTUPITEMAF := C_QTEFETENTRAF * (-1);  /* ################################################ */
                     END IF;
                  END IF;

                  V_QTRESTNF := V_QTRESTNF - V_QTUPITEMAF;

                  IF C_QTPROGENTAF <= C_QTEFETENTRAF + V_QTUPITEMAF THEN /* ################################################ */
                     V_IDBAIXITMAF := '2';                               /* AJUSTE DO IDENTIFICADOR DE BAIXA DO ITEM DA AF   */
                  ELSE
                     IF (V_IDCONSVLRMAF = 'S') AND (C_IDBAIXITMAF = '2') AND (V_QTITEMPROD < C_QTPROGENTAF) THEN
                        V_IDBAIXITMAF := NULL;
                     ELSE
                        V_IDBAIXITMAF := '1';
                     END IF;
                  END IF;

                  IF C_QTEFETENTRAF + V_QTUPITEMAF = 0 THEN
                     V_IDBAIXITMAF := NULL;
                     V_DTENTRSAID  := NULL;
                  END IF;
                  V_QTEFETENTRAF := C_QTEFETENTRAF + V_QTUPITEMAF;
               END IF;

               IF V_QTEFETENTRAF = 0 THEN
                  V_QTEFETENTRAF := NULL;
               END IF;

               IF C_IDUTILITEM = '1' THEN
                  UPDATE ITEMAUTF
                  SET  IDBAIXITAFS  = V_IDBAIXITMAF,
                       QTEFAFSAIDOL = V_QTEFETENTRAF,
                       DTEFETENTAF  = V_DTENTRSAID,
                       CDOPERBAIXA  = NULL,
                       DTBAIXITMAF  = NULL
                  WHERE
                   C_CDFILDEST   = ITEMAUTF.CDFILDEST AND
                   C_CDFILLANC   = ITEMAUTF.CDFILLANC AND
                   C_NRAUTOFORN  = ITEMAUTF.NRAUTOFORN AND
                   C_CDPRODUTO   = ITEMAUTF.CDPRODUTO AND
                   C_CDMARCA     = ITEMAUTF.CDMARCA AND
                   C_DTPROGENTAF = ITEMAUTF.DTPROGENTAF;
               END IF;

               IF C_IDUTILITEM = '2' THEN
                  UPDATE ITEMPEDEXOL
                  SET  IDBAIXAOLSAI  = V_IDBAIXITMAF,
                       QTEFETENPEOL  = V_QTEFETENTRAF,
                       DTEFETENPEOL  = V_DTENTRSAID,
                       CDOPERBAIXA   = NULL,
                       DTBAIXTMPEOL  = NULL
                  WHERE
                   C_CDFILDEST   = ITEMPEDEXOL.CDFILDEST AND
                   C_CDFILLANC   = ITEMPEDEXOL.CDFILLANC AND
                   C_NRAUTOFORN  = ITEMPEDEXOL.NRPEDEXOL AND
                   C_CDPRODUTO   = ITEMPEDEXOL.CDPRODUTO AND
                   C_CDMARCA     = ITEMPEDEXOL.CDMARCA   AND
                   C_DTPROGENTAF = ITEMPEDEXOL.DTPROGENPEOL;
               END IF;

               IF V_IDBAIXITMAF IS NULL THEN
                  IF C_IDUTILITEM = '1' THEN
                     DELETE FROM NFRELACAFSAI
                     WHERE
                      C_CDFILDEST   = CDFILDEST AND
                      C_CDFILLANC   = CDFILLANC AND
                      C_NRAUTOFORN  = NRAUTOFORN AND
                      C_CDPRODUTO   = CDPRODUTO AND
                      C_CDMARCA     = CDMARCA AND
                      C_DTPROGENTAF = DTPROGENTAF;
                  END IF;

                  IF C_IDUTILITEM = '2' THEN
                     DELETE FROM NFRELACPEXOL
                     WHERE
                      C_CDFILDEST   = CDFILDEST AND
                      C_CDFILLANC   = CDFILLANC AND
                      C_NRAUTOFORN  = NRPEDEXOL AND
                      C_CDPRODUTO   = CDPRODUTO AND
                      C_CDMARCA     = CDMARCA AND
                      C_DTPROGENTAF = DTPROGENPEOL;
                  END IF;
               END IF;

               V_TOTALITEM    := 0;
               V_BAIXATOTAL   := 0;
               V_BAIXAMANUAL  := 0;
               V_EMABERTO     := 0;
               V_BAIXAPARCIAL := 0;

               IF C_IDUTILITEM = '1' THEN
                  SELECT COUNT(*) INTO V_TOTALITEM -- BUSCA O TOTAL DE ITENS DA AF
                  FROM ITEMAUTF
                  WHERE
                     C_CDFILDEST  = ITEMAUTF.CDFILDEST AND
                     C_CDFILLANC  = ITEMAUTF.CDFILLANC AND
                     C_NRAUTOFORN = ITEMAUTF.NRAUTOFORN;

                  SELECT COUNT(*) INTO V_EMABERTO  -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
                  FROM ITEMAUTF
                  WHERE
                     C_CDFILDEST  = ITEMAUTF.CDFILDEST AND
                     C_CDFILLANC  = ITEMAUTF.CDFILLANC AND
                     C_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS IS NULL;

                  SELECT COUNT(*) INTO V_BAIXAPARCIAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
                  FROM ITEMAUTF
                  WHERE
                     C_CDFILDEST  = ITEMAUTF.CDFILDEST AND
                     C_CDFILLANC  = ITEMAUTF.CDFILLANC AND
                     C_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS = '1';

                  SELECT COUNT(*) INTO V_BAIXATOTAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
                  FROM ITEMAUTF
                  WHERE
                     C_CDFILDEST  = ITEMAUTF.CDFILDEST AND
                     C_CDFILLANC  = ITEMAUTF.CDFILLANC AND
                     C_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS = '2';

                  SELECT COUNT(*) INTO V_BAIXAMANUAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
                  FROM ITEMAUTF
                  WHERE
                     C_CDFILDEST  = ITEMAUTF.CDFILDEST AND
                     C_CDFILLANC  = ITEMAUTF.CDFILLANC AND
                     C_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS = '3';
               END IF;

               IF C_IDUTILITEM = '2' THEN
                  SELECT COUNT(*) INTO V_TOTALITEM -- BUSCA O TOTAL DE ITENS DA AF
                  FROM ITEMPEDEXOL
                  WHERE
                     C_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     C_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     C_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL;

                  SELECT COUNT(*) INTO V_EMABERTO  -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
                  FROM ITEMPEDEXOL
                  WHERE
                     C_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     C_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     C_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI IS NULL;

                  SELECT COUNT(*) INTO V_BAIXAPARCIAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
                  FROM ITEMPEDEXOL
                  WHERE
                     C_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     C_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     C_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI = '1';

                  SELECT COUNT(*) INTO V_BAIXATOTAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
                  FROM ITEMPEDEXOL
                  WHERE
                     C_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     C_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     C_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI = '2';

                  SELECT COUNT(*) INTO V_BAIXAMANUAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
                  FROM ITEMPEDEXOL
                  WHERE
                     C_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     C_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     C_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI = '3';
               END IF;

               IF V_TOTALITEM = V_EMABERTO THEN
                  V_IDBAIXAAF := NULL;  -- AF EM ABERTO
               END IF;
               IF V_TOTALITEM = V_BAIXATOTAL THEN
                  V_IDBAIXAAF := '2';   -- AF COM BAIXA TOTAL
               END IF;
               IF V_BAIXAPARCIAL > 0 THEN
                  V_IDBAIXAAF := '1';   -- AF COM BAIXA PARCIAL
               END IF;
               IF (V_TOTALITEM = V_BAIXATOTAL + V_BAIXAMANUAL) AND
                  (V_BAIXAMANUAL > 0) THEN
                  V_IDBAIXAAF := '3';   -- AF COM BAIXA MANUAL
               END IF;
               IF (V_TOTALITEM = V_BAIXATOTAL + V_BAIXAMANUAL + V_EMABERTO) AND
                  (V_EMABERTO > 0) AND (V_EMABERTO < V_TOTALITEM) THEN
                  V_IDBAIXAAF := '1';   -- AF COM BAIXA PARCIAL
               END IF;

               IF C_IDUTILITEM = '1' THEN
                  UPDATE AUTOFORNE  -- ALTERA O ID DE BAIXA DA AF
                  SET IDBAIXAFSAI = V_IDBAIXAAF
                  WHERE
                     C_CDFILDEST  = AUTOFORNE.CDFILDEST AND
                     C_CDFILLANC  = AUTOFORNE.CDFILLANC AND
                     C_NRAUTOFORN = AUTOFORNE.NRAUTOFORN;
               END IF;

               IF C_IDUTILITEM = '2' THEN
                  UPDATE PEDIDOEXOL  -- ALTERA O ID DE BAIXA DA AF
                  SET IDBAIXEXSAI = V_IDBAIXAAF
                  WHERE
                     C_CDFILDEST  = PEDIDOEXOL.CDFILDEST AND
                     C_CDFILLANC  = PEDIDOEXOL.CDFILLANC AND
                     C_NRAUTOFORN = PEDIDOEXOL.NRPEDEXOL;
               END IF;

            END LOOP;

            IF INSERTING THEN
               CLOSE C_ITEMAUFSAI_INSERT;
            ELSE
               CLOSE C_ITEMAUFSAI;
            END IF;

         ELSE --CASO A NOTA SEJA DE IMPORTAO DE SOLICITAO DE COMPRA
            V_CDPRODCNV := NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO);
            V_VRFATUNEST := 1;

            SELECT
              MAX(NRSOLICMP), MAX(DTPROGENTR), MAX(CDFILLAN)
            INTO V_NRSOLICMP, V_DTENTREGASOLI, V_CDFILILANC
            FROM
              NFRELACSOLI
            WHERE CDFILSOLI  = V_CDFILIRECE
              AND CDPRODUTO  = V_CDPRODCNV
              AND ((CDFILIAL = :OLD.CDFILIAL AND NRLANCTONF = :OLD.NRLANCTONF)
                OR (CDFILIAL = :NEW.CDFILIAL AND NRLANCTONF = :NEW.NRLANCTONF));

            IF V_NRSOLICMP IS NULL THEN
               SELECT
                  MAX(NF.NRSOLICMP), MAX(NF.CDFILSOLI), MAX(NF.DTPROGENTR), MAX(CN.CDPRODUTO), MAX(CN.VRFATUNEST)
               INTO V_NRSOLICMP, V_CDFILIRECE, V_DTENTREGASOLI, V_CDPRODCNV, V_VRFATUNEST
               FROM
                 NFRELACSOLI NF, CNVPRODUNEST CN
               WHERE NF.CDFILLAN     = V_CDFILILANC
                 AND CN.CDPRODUTO(+) = NF.CDPRODUTO
                 AND (CN.CDPRUNEST   = V_CDPRODCNV)
                 AND ((NF.CDFILIAL   = :OLD.CDFILIAL AND NF.NRLANCTONF = :OLD.NRLANCTONF)
                   OR (NF.CDFILIAL   = :NEW.CDFILIAL AND NF.NRLANCTONF = :NEW.NRLANCTONF));
            END IF;

            IF V_NRSOLICMP IS NOT NULL THEN
               IF INSERTING THEN -- SE ESTIVER INSERINDO UM ITEM DA NF
                  UPDATE ITEMSOLI  -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA PARCIAL
                  SET  IDBAIXITMSOL = '1',
                       QTTRANSFSOL  = (:NEW.QTITEMPROD*V_VRFATUNEST) + NVL(QTTRANSFSOL, 0)
                  WHERE NRSOLICMP  = V_NRSOLICMP
                    AND CDFILLAN   = V_CDFILILANC
                    AND CDFILSOLI  = V_CDFILIRECE
                    AND DTPROGENTR = V_DTENTREGASOLI
                    AND CDPRODUTO  = V_CDPRODCNV       AND
                    (:NEW.QTITEMPROD*V_VRFATUNEST) + NVL(QTTRANSFSOL,0) < QTSOLIPROD;

                  IF SQL%ROWCOUNT = 0 THEN -- SE HOUVE ALTERAO
                     UPDATE ITEMSOLI -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA TOTAL
                     SET  IDBAIXITMSOL  = '2',
                          QTTRANSFSOL = (:NEW.QTITEMPROD*V_VRFATUNEST) + NVL(QTTRANSFSOL, 0)
                     WHERE
                       NRSOLICMP  = V_NRSOLICMP   AND
                       CDFILLAN   = V_CDFILILANC  AND
                       CDFILSOLI  = V_CDFILIRECE  AND
                       DTPROGENTR = V_DTENTREGASOLI  AND
                       CDPRODUTO  = V_CDPRODCNV   AND
                       (:NEW.QTITEMPROD*V_VRFATUNEST) + NVL(QTTRANSFSOL, 0) >= QTSOLIPROD;
                  END IF;
               END IF;

               IF UPDATING THEN  -- SE ESTIVER ALTERANDO UM ITEM DA NF (SOMENTE O CAMPO QTITEMPROD)
                  UPDATE ITEMSOLI -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA PARCIAL
                  SET  IDBAIXITMSOL  = '1',
                       QTTRANSFSOL = ((NVL(QTTRANSFSOL,0) - (:OLD.QTITEMPROD*V_VRFATUNEST)) + (:NEW.QTITEMPROD*V_VRFATUNEST))
                  WHERE
                    NRSOLICMP  = V_NRSOLICMP       AND
                    CDFILLAN   = V_CDFILILANC      AND
                    CDFILSOLI  = V_CDFILIRECE      AND
                    DTPROGENTR = V_DTENTREGASOLI      AND
                    CDPRODUTO  = V_CDPRODCNV       AND
                   ((NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST)) + (:NEW.QTITEMPROD*V_VRFATUNEST)) < QTSOLIPROD;

                  IF SQL%ROWCOUNT = 0 THEN
                     UPDATE ITEMSOLI  -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA TOTAL
                     SET  IDBAIXITMSOL  = '2',
                          QTTRANSFSOL = ((NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST)) + (:NEW.QTITEMPROD*V_VRFATUNEST))
                     WHERE
                       NRSOLICMP  = V_NRSOLICMP       AND
                       CDFILLAN   = V_CDFILILANC      AND
                       CDFILSOLI  = V_CDFILIRECE      AND
                       DTPROGENTR = V_DTENTREGASOLI      AND
                       CDPRODUTO  = V_CDPRODCNV       AND
                      ((NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST)) + (:NEW.QTITEMPROD*V_VRFATUNEST)) >= QTSOLIPROD;
                  END IF;
               END IF;

               IF DELETING THEN  -- SE ESTIVER DELETANDO UM ITEM DA NF
                  UPDATE ITEMSOLI -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA PARCIAL
                  SET  IDBAIXITMSOL  = '1',
                       QTTRANSFSOL   = NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST)
                  WHERE
                    NRSOLICMP  = V_NRSOLICMP       AND
                    CDFILLAN   = V_CDFILILANC      AND
                    CDFILSOLI  = V_CDFILIRECE      AND
                    DTPROGENTR = V_DTENTREGASOLI      AND
                    CDPRODUTO  = V_CDPRODCNV       AND
                   (NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST) < QTSOLIPROD) AND
                   (NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST) > 0);

                  IF SQL%ROWCOUNT = 0 THEN
                     UPDATE ITEMSOLI -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA TOTAL
                     SET  IDBAIXITMSOL  = '2',
                          QTTRANSFSOL = NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST)
                     WHERE
                      NRSOLICMP  = V_NRSOLICMP       AND
                      CDFILLAN   = V_CDFILILANC      AND
                      CDFILSOLI  = V_CDFILIRECE      AND
                      DTPROGENTR = V_DTENTREGASOLI      AND
                      CDPRODUTO  = V_CDPRODCNV       AND
                      NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST) >= QTSOLIPROD;

                     IF SQL%ROWCOUNT = 0 THEN
                        UPDATE ITEMSOLI -- ALTERA O ID DE BAIXA DO ITEM DA SOL PARA ABERTO
                        SET  IDBAIXITMSOL  = NULL,
                             QTTRANSFSOL   = NULL
                        WHERE
                          NRSOLICMP  = V_NRSOLICMP       AND
                          CDFILLAN   = V_CDFILILANC      AND
                          CDFILSOLI  = V_CDFILIRECE      AND
                          DTPROGENTR = V_DTENTREGASOLI      AND
                          CDPRODUTO  = V_CDPRODCNV       AND
                          NVL(QTTRANSFSOL, 0) - (:OLD.QTITEMPROD*V_VRFATUNEST) <= 0;
                     END IF;
                  END IF;
               END IF;

               V_TOTALITEM    := 0;
               V_BAIXATOTAL   := 0;
               V_BAIXAMANUAL  := 0;
               V_EMABERTO     := 0;
               V_BAIXAPARCIAL := 0;

               SELECT
                 COUNT(*) INTO V_TOTALITEM -- BUSCA O TOTAL DE ITENS DA SOL
               FROM
                 ITEMSOLI
               WHERE
                 NRSOLICMP = V_NRSOLICMP  AND
                 CDFILLAN  = V_CDFILILANC AND
                 CDFILSOLI = V_CDFILIRECE;

               SELECT
                 COUNT(*) INTO V_EMABERTO  -- BUSCA O TOTAL DE ITENS DA SOL EM ABERTO
               FROM
                 ITEMSOLI
               WHERE
                 NRSOLICMP  = V_NRSOLICMP  AND
                 CDFILLAN   = V_CDFILILANC AND
                 CDFILSOLI  = V_CDFILIRECE AND
                 IDBAIXITMSOL IS NULL;

               SELECT
                 COUNT(*) INTO V_BAIXAPARCIAL -- BUSCA O TOTAL DE ITENS DA SOL COM BAIXA PARCIAL
               FROM
                 ITEMSOLI
               WHERE
                 NRSOLICMP    = V_NRSOLICMP  AND
                 CDFILLAN     = V_CDFILILANC AND
                 CDFILSOLI    = V_CDFILIRECE AND
                 IDBAIXITMSOL = '1';

               SELECT
                 COUNT(*) INTO V_BAIXATOTAL -- BUSCA O TOTAL DE ITENS DA SOL COM BAIXA TOTAL
               FROM
                 ITEMSOLI
               WHERE
                 NRSOLICMP    = V_NRSOLICMP  AND
                 CDFILLAN     = V_CDFILILANC AND
                 CDFILSOLI    = V_CDFILIRECE AND
                 IDBAIXITMSOL = '2';

               SELECT
                 COUNT(*) INTO V_BAIXAMANUAL -- BUSCA O TOTAL DE ITENS DA SOL COM BAIXA MANUAL
               FROM
                 ITEMSOLI
               WHERE
                 NRSOLICMP    = V_NRSOLICMP  AND
                 CDFILLAN     = V_CDFILILANC AND
                 CDFILSOLI    = V_CDFILIRECE AND
                 IDBAIXITMSOL = '3';

               IF V_TOTALITEM = V_EMABERTO THEN
                  V_IDBAIXAAF := NULL;  -- SOL EM ABERTO
               END IF;
               IF V_TOTALITEM = V_BAIXATOTAL THEN
                  V_IDBAIXAAF := '2';   -- SOL COM BAIXA TOTAL
               END IF;
               IF V_BAIXAPARCIAL > 0 THEN
                  V_IDBAIXAAF := '1';   -- SOL COM BAIXA PARCIAL
               END IF;
               IF (V_TOTALITEM = V_BAIXATOTAL + V_BAIXAMANUAL) AND
                  (V_BAIXAMANUAL > 0) THEN
                  V_IDBAIXAAF := '3';   -- SOL COM BAIXA MANUAL
               END IF;
               IF (V_TOTALITEM = V_BAIXATOTAL + V_BAIXAMANUAL + V_EMABERTO) AND
                  (V_EMABERTO > 0) AND (V_EMABERTO < V_TOTALITEM) THEN
                  V_IDBAIXAAF := '1';   -- SOL COM BAIXA PARCIAL
               END IF;

               UPDATE SOLICITA  -- ALTERA O ID DE BAIXA DA SOL
               SET IDBAIXASOL = V_IDBAIXAAF
               WHERE
                 NRSOLICMP    = V_NRSOLICMP  AND
                 CDFILLANCA   = V_CDFILILANC AND
                 CDFILSOLI    = V_CDFILIRECE;
            END IF;
         END IF;
      END IF;
   END IF;      
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('NF_BAIXA_SAIDA','5.50.xxx'); END;
/
