import { ZdPage } from '@zeedhi/vue';

const routes = [
    {
        path: '/auth/login',
        name: 'login',
        component: ZdPage,
        props: {
            path: 'login',
            local: true,
        },
    },
    {
        path: '/',
        name: 'home',
        component: ZdPage,
        props: {
            path: 'home',
            local: true,
        },
    },
    {
        path: '/dashboard',
        name: 'dashboard',
        component: ZdPage,
        props: {
            path: '/dashboard/dashboard',
            local: true,
        },
    },
    {
        path: '/centroCustoRelatorio',
        name: 'Relatorio Centro Custo',
        component: ZdPage,
        props: {
            path: '/centroCustoRelatorio',
            local: true,
        },
    },
    {
        path: '/billingComparison',
        name: 'Billing Comparison',
        component: ZdPage,
        props: {
            path: '/billing/BillingComparison',
            local: true,
        },
    },
    {
        path: '/billingComparisonDetail',
        name: 'Billing Comparison Detail',
        component: ZdPage,
        props: {
            path: '/billing/BillingComparisonDetail',
            local: true,
        },
    },
    {
        path: '/logCallbackCertisign',
        name: 'logCallbackCertisign',
        component: ZdPage,
        props: {
            path: '/CallbackCertisign/logCallbackCertisign',
            local: true,
        },
    },
    {
        path: '/clientesNaoFaturadosRelatorio',
        name: 'clientesNaoFaturadosRelatorio',
        component: ZdPage,
        props: {
            path: '/clientesNaoFaturadosRelatorio',
            local: true,
        },
    },
    {
        path: '/sm_next_00049_000_agrupamento_contratos_faturamento',
        name: 'Agrupamento de Contratos para Faturamento',
        component: ZdPage,
        props: {
            path: '/Faturamento/sm_next_00049_000_agrupamento_contratos_faturamento',
            local: true,
        },
    },
    {
        path: '/sm_next_00006_000_servicos',
        name: 'Serviços',
        component: ZdPage,
        props: {
            path: '/Service/sm_next_00006_000_servicos',
            local: true,
        },
    },
    {
        path: '/sm_00037_000_motivo_negociacao',
        name: 'motivoNegociacao',
        component: ZdPage,
        props: {
            path: '/sm_00037_000_motivo_negociacao',
            local: true,
        },
    },
    {
        path: '/sm_00016_000_tipo_anexo',
        name: 'tipoAnexo',
        component: ZdPage,
        props: {
            path: '/sm_00016_000_tipo_anexo',
            local: true,
        },
    },
    {
        path: '/sm_00004_110_tipo_rescisao',
        name: 'tipoRescisao',
        component: ZdPage,
        props: {
            path: '/sm_00004_110_tipo_rescisao',
            local: true,
        },
    },
    {
        path: '/sm_00036_000_motivo_rescisao',
        name: 'motivoRecisao',
        component: ZdPage,
        props: {
            path: '/sm_00036_000_motivo_rescisao',
            local: true,
        },
    },
    {
        path: '/sm_00024_000_modelo_documentos',
        name: 'Modelo de Documento',
        component: ZdPage,
        props: {
            path: '/sm_00024_000_modelo_documentos/sm_00024_000_modelo_documentos',
            local: true,
        },
    },
    {
        path: '/sm_00006_000_tipo_de_medida',
        name: 'Tipo De Medida',
        component: ZdPage,
        props: {
            path: '/sm_00006_000_tipo_de_medida/sm_00006_000_tipo_de_medida',
            local: true,
        },
    },
    {
        path: '/sm_00029_001_tipo_local_atendimento',
        name: 'Tipo de Local de Atendimento',
        component: ZdPage,
        props: {
            path: '/sm_00029_001_tipo_local_atendimento',
            local: true,
        },
    },
    {
        path: '/sm_00001_002_proposta_historico',
        name: 'Histórico de Alterações da Proposta',
        component: ZdPage,
        props: {
            path: '/sm_00001_002_proposta_historico/sm_00001_002_proposta_historico',
            local: true,
        },
    },
    {
        path: '/sm_00034_000_desconto_periodo_carencia',
        name: 'sm_00034_000_desconto_periodo_carencia',
        component: ZdPage,
        props: {
            path: '/sm_00034_000_desconto_periodo_carencia/sm_00034_000_desconto_periodo_carencia',
            local: true,
        },
    },
    {
        path: '/sm_00057_000_configuracao_regional',
        name: 'sm_00057_000_configuracao_regional',
        component: ZdPage,
        props: {
            path: '/sm_00057_000_configuracao_regional/sm_00057_000_configuracao_regional',
            local: true,
        },
    },
    {
        path: '/sm_00058_000_configuracoes_proposta',
        name: 'sm_00058_000_configuracoes_proposta',
        component: ZdPage,
        props: {
            path: '/sm_00058_000_configuracoes_proposta/sm_00058_000_configuracoes_proposta',
            local: true,
        },
    },
    {
        path: '/sm_00011_000_apuracao_faturamento',
        name: 'sm_00011_000_apuracao_faturamento',
        component: ZdPage,
        props: {
            path: '/sm_00011_000_apuracao_faturamento/sm_00011_000_apuracao_faturamento',

        },
    },
    {
        path: '/sm_00001_001_documento_proposta_grid',
        name: 'sm_00001_001_documento_proposta_grid',
        component: ZdPage,
        props: {
            path: '/sm_00001_001_documento_proposta/sm_00001_001_documento_proposta_grid',
            local: true,
        },
        
    },
    {
        path: '/sm_00005_000_parametrizacoes_services',
        name: 'sm_00005_000_parametrizacoes_services',
        component: ZdPage,
        props: {
            path: '/sm_00005_000_parametrizacoes_services/sm_00005_000_parametrizacoes_services',
            local: true,
        },
    },
    {
        path: '/sm_00004_006_documento_contrato_grid',
        name: 'sm_00004_006_documento_contrato_grid',
        component: ZdPage,
        props: {
            path: '/sm_00004_006_documento_contrato/sm_00004_006_documento_contrato_grid',
            local: true,
        },
    },
    {
        path: '/sm_00070_000_hierarquia_operadores',
        name: 'sm_00070_000_hierarquia_operadores',
        component: ZdPage,
        props: {
            path: '/sm_00070_000_hierarquia_operadores/sm_00070_000_hierarquia_operadores',
            local: true,
        },
    },
    {
        path: '/agenda_servicos_grid',
        name: 'agenda_servicos_grid',
        component: ZdPage,
        props: {
            path: '/agendaServicos/agenda_servicos_grid',
            local: true,
        },
    },
    {
        path: '/modules/:module/:page',
        name: 'microservice',
        component: () => import('../views/Microservice.vue'),
    },
    {
        path: '*',
        component: ZdPage,
        props: {
            path: 'notfound',
            local: true,
        },
    },
];

export default routes;
